{
  "custom": {},
  "params": {
    "alarm_states": [
      "Shelved",
      "Active",
      "Not Active"
    ],
    "length_of_table_data": 0,
    "show_filter": false,
    "show_severity_column": true,
    "show_state_column": true,
    "table_type": "value",
    "tagProps": [
      ""
    ]
  },
  "propConfig": {
    "params.alarm_states": {
      "paramDirection": "input",
      "persistent": true
    },
    "params.length_of_table_data": {
      "binding": {
        "config": {
          "expression": "len({/root/Table.props.data})"
        },
        "type": "expr"
      },
      "paramDirection": "output",
      "persistent": true
    },
    "params.show_filter": {
      "paramDirection": "input",
      "persistent": true
    },
    "params.show_severity_column": {
      "paramDirection": "input",
      "persistent": true
    },
    "params.show_state_column": {
      "paramDirection": "input",
      "persistent": true
    },
    "params.table_type": {
      "paramDirection": "input",
      "persistent": true
    },
    "params.tagProps": {
      "paramDirection": "input",
      "persistent": true
    }
  },
  "props": {
    "defaultSize": {
      "height": 1080,
      "width": 1920
    }
  },
  "root": {
    "children": [
      {
        "custom": {
          "alarms_to_shelve": {},
          "alarms_to_unshelve": {},
          "delay": 2000,
          "run_export": false,
          "run_update": true,
          "severity_filters": [
            "off",
            "off",
            "off",
            "off",
            "off"
          ],
          "shelve_alarms": false,
          "shelve_duration": "",
          "unshelve_alarms": false
        },
        "events": {
          "component": {
            "onRowClick": [
              {
                "config": {
                  "script": "\n\talarm_id \u003d event.value.Alarm_id\n\tsource_id \u003d event.value.SourceId\n\tif self.props.data[event.row].value.Shelve.value \u003d\u003d True:\n\t\tself.props.data[event.row].value.Shelve.value \u003d False\n\t\tkey \u003d alarms.alarm_tables.create_shelve_key(source_id, alarm_id)\n\t\tself.custom.alarms_to_shelve.pop(key, \"no key found\")\n\telse:\n\t\tself.props.data[event.row].value.Shelve.value \u003d True\n\t\tkey \u003d alarms.alarm_tables.create_shelve_key(source_id, alarm_id)\n\t\tself.custom.alarms_to_shelve[key] \u003d event.value.Alarm_id"
                },
                "scope": "G",
                "type": "script"
              },
              {
                "config": {
                  "script": "\tif self.view.params.table_type \u003d\u003d \"Shelved\":\n\t\talarm_id \u003d event.value.Alarm_id\n\t\tsource_id \u003d event.value.SourceId\n\t\t\n\t\tif self.props.data[event.row].value.Unshelve.value \u003d\u003d True:\n\t\t\tself.props.data[event.row].value.Unshelve.value \u003d False\n\t\t\tkey \u003d alarms.alarm_tables.create_shelve_key(source_id, alarm_id)\n\t\t\tself.custom.alarms_to_unshelve.pop(key, \"no key found\")\n\t\telse:\n\t\t\tself.props.data[event.row].value.Unshelve.value \u003d True\n\t\t\tkey \u003d alarms.alarm_tables.create_shelve_key(source_id, alarm_id)\n\t\t\tself.custom.alarms_to_unshelve[key] \u003d event.value.Alarm_id"
                },
                "scope": "G",
                "type": "script"
              }
            ],
            "onRowDoubleClick": {
              "config": {
                "script": "\trow \u003d event.value\n\tsource_id \u003d row.get(\"SourceId\")\n\tsource_id \u003d source_id.replace(\" \",\"\")\n\tconfig.project_config.source_id_lookup(self, source_id)"
              },
              "scope": "G",
              "type": "script"
            }
          }
        },
        "meta": {
          "name": "Table"
        },
        "position": {
          "basis": "1080px"
        },
        "propConfig": {
          "custom.device": {
            "binding": {
              "config": {
                "path": "view.params.tagProps[0]"
              },
              "type": "property"
            }
          },
          "custom.run_export": {
            "onChange": {
              "enabled": null,
              "script": "\trun_export \u003d self.custom.run_export\n\tif run_export:\n\t\tdata \u003d self.props.data\n\t\trow_data \u003d []\n\t\tfor i,j in enumerate(data):\n\t\t\tvalue \u003d j[\"value\"]\n\t\t\tif i \u003d\u003d 0:\n\t\t\t\theader \u003d [item for item in value] \t\n\t\t\trow \u003d [value[item][\"value\"] for item in value]\n\t\t\tif not isinstance(row[3], int):\n\t\t\t\trow[3] \u003d 0\t\t\t\n\t\t\trow_data.append(row) \n\t\t\n\t\talarms_data \u003d system.dataset.toDataSet(header,row_data)\n\t\thtml_data \u003d system.dataset.dataSetToHTML(1, alarms_data, \"RealTimeAlarms\")\n\t\tsystem.perspective.download(\"myExport.html\",html_data)\n\t\tself.custom.run_export \u003d False"
            }
          },
          "custom.severity_filters[0]": {
            "access": "PRIVATE"
          },
          "custom.shelve_alarms": {
            "onChange": {
              "enabled": null,
              "script": "\tif self.custom.shelve_alarms:\n\t\tsource_ids_to_shelve \u003d []\n\t\tids_to_shelve \u003d [] \n\t\tfor k,v in self.custom.alarms_to_shelve.items():\n\t\t\tsource_id, alarm_id \u003d alarms.alarm_tables.unformat_shelve_key(k)\n\t\t\tsource_ids_to_shelve .append(source_id)\n\t\t\tids_to_shelve.append(alarm_id)\n\t\twhid \u003d self.session.custom.fc\n\t\tduration \u003d self.custom.shelve_duration\n\t\tCommands.shelve_alarms.send_shelve_request(whid, source_ids_to_shelve, \"shelve\", duration, ids_to_shelve)\n\t\tself.custom.alarms_to_shelve \u003d {}\n\t\tself.custom.shelve_alarms \u003d False\n\t\t \t"
            }
          },
          "custom.unshelve_alarms": {
            "onChange": {
              "enabled": null,
              "script": "\tif self.custom.unshelve_alarms:\n\t\tsource_ids_to_shelve \u003d []\n\t\tids_to_shelve \u003d [] \n\t\tfor k,v in self.custom.alarms_to_unshelve.items():\n\t\t\tsource_id, alarm_id \u003d alarms.alarm_tables.unformat_shelve_key(k)\n\t\t\tsource_ids_to_shelve .append(source_id)\n\t\t\tids_to_shelve.append(alarm_id)\n\t\twhid \u003d self.session.custom.fc\n\t\tduration \u003d 0\n\t\tCommands.shelve_alarms.send_shelve_request(whid, source_ids_to_shelve, \"unshelve\", duration, ids_to_shelve)\n\t\tself.custom.alarms_to_unshelve \u003d {}\n\t\tself.custom.unshelve_alarms \u003d False"
            }
          },
          "custom.update": {
            "binding": {
              "config": {
                "expression": "if({this.custom.run_update},\r\nnow({this.custom.delay}), False)"
              },
              "type": "expr"
            },
            "onChange": {
              "enabled": null,
              "script": "\n\tno_filter \u003d False\n\tseverity_filters \u003d self.custom.severity_filters\n\talarm_states \u003d self.view.params.alarm_states\n\ttable_type \u003d self.view.params.table_type\n\twhid \u003d self.session.custom.fc\n\talarms_to_shelve \u003d self.custom.alarms_to_shelve\n\tprovider \u003d \"[%s_SCADA_TAG_PROVIDER]\" % (whid)\n\tif (severity_filters[0] \u003d\u003d \"off\" and severity_filters[1] \u003d\u003d \"off\" \n\tand severity_filters[2] \u003d\u003d \"off\" and severity_filters[3] \u003d\u003d \"off\" \n\tand severity_filters[4] \u003d\u003d \"off\"):\n\t    no_filter \u003d True\n\t\n\tif system.tag.exists(provider + \"System/aws_data\"):\n\t\ttags_to_read \u003d system.tag.readBlocking([provider + \"System/aws_data\", \n\t\t\t\t\t\t\t\t\t\t\t\tprovider + \"Configuration/DetailedViews\"])\n\t\tdecode_alarm_data \u003d system.util.jsonDecode(tags_to_read[0].value)\n\t\tdetailed_view_decoded \u003d system.util.jsonDecode(tags_to_read[1].value)\n\t\tif self.view.params.table_type \u003d\u003d \"Docked-East\":\n\t\t\tdevice_list \u003d [self.custom.device] \n\t\telse:\n\t\t\tdevice_list \u003d detailed_view_decoded.get(self.custom.device,[])\n\t\tif len(decode_alarm_data) \u003e 0:\n\t\t\talt_colour \u003d self.session.custom.colours.colour_impaired\n\t\t\talarms_data \u003d alarms.alarm_tables.get_alarm_table(self, decode_alarm_data, \n\t\t\tseverity_filters, no_filter, device_list, alarm_states, alt_colour,\n\t\t\ttable_type)\t\t\n\t\t\tif len(alarms_data)\u003e0:\n\t\t\t\tself.props.data \u003d alarms_data\n\t\t\telse:\n\t\t\t\tself.props.data \u003d []\n\t\telse:\n\t\t\tself.props.data \u003d []\n\telse:\n\t\tself.props.data \u003d []"
            }
          },
          "props.columns[2].visible": {
            "binding": {
              "config": {
                "expression": "if({view.params.table_type} \u003d \"Shelved\", False, True)"
              },
              "type": "expr"
            }
          },
          "props.columns[3].visible": {
            "binding": {
              "config": {
                "expression": "if({view.params.table_type} \u003d \"Shelved\", False, True)"
              },
              "type": "expr"
            }
          },
          "props.columns[4].visible": {
            "binding": {
              "config": {
                "expression": "if({view.params.table_type} \u003d \"Shelved\", False, True)"
              },
              "type": "expr"
            }
          },
          "props.columns[5].visible": {
            "binding": {
              "config": {
                "path": "view.params.show_severity_column"
              },
              "type": "property"
            }
          },
          "props.columns[6].visible": {
            "binding": {
              "config": {
                "expression": "if({view.params.table_type} \u003d \"Shelved\", True, False)"
              },
              "type": "expr"
            }
          },
          "props.columns[7].visible": {
            "binding": {
              "config": {
                "expression": "if({view.params.table_type} \u003d \"Shelved\", False, True)"
              },
              "type": "expr"
            }
          },
          "props.columns[8].visible": {
            "binding": {
              "config": {
                "expression": "if({view.params.table_type} \u003d \"Shelved\", True, False)"
              },
              "type": "expr"
            }
          },
          "props.filter.enabled": {
            "binding": {
              "config": {
                "path": "view.params.show_filter"
              },
              "type": "property"
            }
          },
          "props.selection.data": {
            "onChange": {
              "enabled": null,
              "script": "\tpayload \u003d self.props.selection.data\n\tsystem.perspective.sendMessage(\"alarms-to-shelve\", payload \u003d payload, scope \u003d \"page\")"
            }
          }
        },
        "props": {
          "cells": {
            "style": {
              "marginLeft": 5,
              "marginRight": 5,
              "overflowWrap": "normal",
              "wordWrap": "normal"
            }
          },
          "columns": [
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "SourceId",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "visible": true,
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "Message",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "visible": true,
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY HH:mm:ss",
              "editable": false,
              "field": "Timestamp",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "Duration",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "00:00:00",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "State",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "Priority",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY HH:mm:ss",
              "editable": false,
              "field": "Expiration",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": true,
              "field": "Shelve",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "center",
              "nullFormat": {
                "includeNullStrings": false,
                "nullFormatValue": "",
                "strict": false
              },
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": true,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": 100
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": true,
              "field": "Unshelve",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "center",
              "nullFormat": {
                "includeNullStrings": false,
                "nullFormatValue": "",
                "strict": false
              },
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": true,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "width": 100
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "Alarm_id",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "nullFormat": {
                "includeNullStrings": false,
                "nullFormatValue": "",
                "strict": false
              },
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "visible": false,
              "width": ""
            },
            {
              "align": "center",
              "boolean": "checkbox",
              "dateFormat": "MM/DD/YYYY",
              "editable": false,
              "field": "Type",
              "filter": {
                "boolean": {
                  "condition": ""
                },
                "date": {
                  "condition": "",
                  "value": ""
                },
                "enabled": false,
                "number": {
                  "condition": "",
                  "value": ""
                },
                "string": {
                  "condition": "",
                  "value": ""
                },
                "visible": "on-hover"
              },
              "footer": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "header": {
                "align": "center",
                "justify": "left",
                "style": {
                  "classes": ""
                },
                "title": ""
              },
              "justify": "auto",
              "nullFormat": {
                "includeNullStrings": false,
                "nullFormatValue": "",
                "strict": false
              },
              "number": "value",
              "numberFormat": "0,0.##",
              "progressBar": {
                "bar": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "max": 100,
                "min": 0,
                "track": {
                  "color": "",
                  "style": {
                    "classes": ""
                  }
                },
                "value": {
                  "enabled": true,
                  "format": "0,0.##",
                  "justify": "center",
                  "style": {
                    "classes": ""
                  }
                }
              },
              "render": "auto",
              "resizable": true,
              "sort": "none",
              "sortable": true,
              "strictWidth": false,
              "style": {
                "classes": ""
              },
              "toggleSwitch": {
                "color": {
                  "selected": "",
                  "unselected": ""
                }
              },
              "viewParams": {},
              "viewPath": "",
              "visible": true,
              "width": ""
            }
          ],
          "emptyMessage": {
            "noData": {
              "icon": {
                "color": "#000000"
              }
            }
          },
          "filter": {},
          "headerStyle": {
            "classes": "Background-Styles/Controller"
          },
          "selection": {
            "mode": "multiple interval"
          }
        },
        "scripts": {
          "customMethods": [],
          "extensionFunctions": null,
          "messageHandlers": [
            {
              "messageType": "severity-filters",
              "pageScope": true,
              "script": "\n\tcritical \u003d payload.get(\"critical\")\n\tif critical \u003d\u003d \"true\":\n\t\tself.custom.severity_filters[5] \u003d 5\n\tif critical \u003d\u003d \"false\":\n\t\tself.custom.severity_filters[5] \u003d \"off\"\n\t\n\thigh \u003d payload.get(\"high\")\n\tif high \u003d\u003d \"true\":\n\t\tself.custom.severity_filters[4] \u003d 4\n\tif high \u003d\u003d \"false\":\n\t\tself.custom.severity_filters[4] \u003d \"off\"\n\t\n\tmedium \u003d payload.get(\"medium\")\n\tif medium \u003d\u003d \"true\":\n\t\tself.custom.severity_filters[3] \u003d 3\n\tif medium \u003d\u003d \"false\":\n\t\tself.custom.severity_filters[3] \u003d \"off\"\n\t\n\tlow \u003d payload.get(\"low\")\n\tif low \u003d\u003d \"true\":\n\t\tself.custom.severity_filters[2] \u003d 2\n\tif low \u003d\u003d \"false\":\n\t\tself.custom.severity_filters[2] \u003d \"off\"\n\t\n\tdiagnostic \u003d payload.get(\"diagnostic\")\n\tif diagnostic \u003d\u003d \"true\":\n\t\tself.custom.severity_filters[1] \u003d 1\n\tif diagnostic \u003d\u003d \"false\":\n\t\tself.custom.severity_filters[1] \u003d \"off\"",
              "sessionScope": false,
              "viewScope": false
            },
            {
              "messageType": "update-table",
              "pageScope": true,
              "script": "\t# implement your handler here\n\tupdate \u003d payload[\"update\"]\n\tself.custom.run_update \u003d update",
              "sessionScope": false,
              "viewScope": false
            },
            {
              "messageType": "run-alarm-export",
              "pageScope": true,
              "script": "\t# implement your handler here\n\tif self.view.params.table_type \u003d\u003d \"Realtime\":\n\t\texport \u003d payload[\"export\"]\n\t\tself.custom.run_export \u003d export",
              "sessionScope": false,
              "viewScope": false
            },
            {
              "messageType": "reset-filters",
              "pageScope": true,
              "script": "\tbackground \u003d \"false\"\n\tseverity \u003d payload[\"reset\"]\n\tseverity_filters \u003d self.custom.severity_filters\n\tseverity_filters[0] \u003d \"off\"\n\tseverity_filters[1] \u003d \"off\"\n\tseverity_filters[2] \u003d \"off\"\n\tseverity_filters[3] \u003d \"off\"\n\tseverity_filters[4] \u003d \"off\"\n\tself.custom.alarms_to_shelve \u003d {}",
              "sessionScope": false,
              "viewScope": false
            },
            {
              "messageType": "shelve-alarms",
              "pageScope": true,
              "script": "\tduration \u003d payload[\"duration\"]\n\tself.custom.shelve_duration \u003d duration\n\tself.custom.shelve_alarms \u003d True",
              "sessionScope": false,
              "viewScope": false
            },
            {
              "messageType": "unshelve-alarms",
              "pageScope": true,
              "script": "\tself.custom.unshelve_alarms \u003d True",
              "sessionScope": false,
              "viewScope": false
            }
          ]
        },
        "type": "ia.display.table"
      }
    ],
    "meta": {
      "name": "root"
    },
    "props": {
      "direction": "column"
    },
    "type": "ia.container.flex"
  }
}